﻿using System;
using System.Web.UI.WebControls;
using System.Collections.Generic;
using ProEnt.Chap8.EFBugTracker.Model;

namespace ProEnt.Chap8.EFBugTracker
{
    public partial class ApplicationDetail : System.Web.UI.Page
    {
        private ApplicationDAO _applicationDAO;
        private BugDAO _bugDAO;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!this.IsPostBack)
            {
                ShowApplication();
            }
        }

        protected void grdBugs_RowDeleting(object sender, GridViewDeleteEventArgs e)
        {
            int bugId = (int)grdBugs.DataKeys[e.RowIndex].Values[0];

            BugDAO.DeleteBy(bugId);
            
            ShowApplication();
        }

        private void ShowApplication()
        {
            Application application = ApplicationDAO.FindBy(CurrentApplicationId());
            this.txtApplicationName.Text = application.Name;
            this.txtApplicationMoreDetails.Text = application.MoreDetails;

            List<Bug> bugs = BugDAO.FindAllByApplication(application.ApplicationId);

            this.grdBugs.DataSource = bugs;
            this.grdBugs.DataBind(); 
        }

        private ApplicationDAO ApplicationDAO
        {
            get
            {
                if (_applicationDAO == null)
                    _applicationDAO = new ApplicationDAO();

                return _applicationDAO;
            }
        }

        private BugDAO BugDAO
        {
            get
            {
                if (_bugDAO == null)
                    _bugDAO = new BugDAO();

                return _bugDAO;
            }
        }

        public int CurrentApplicationId()
        {
            int applicationId;
            applicationId = Int32.Parse(Request.QueryString["ApplicationId"]);
            return applicationId;
        }

        public Boolean IsNotFixed(Boolean isFixed)
        {
            return !isFixed;
        }

        protected void btnAddBug_Click(object sender, EventArgs e)
        {
            Application application = ApplicationDAO.FindBy(CurrentApplicationId());
            
            Bug newBug = new Bug();
            newBug.Desc = this.txtBugDesc.Text;
            newBug.Application = application;
            application.Bugs.Add(newBug);

            ApplicationDAO.Save(application);
            
            ShowApplication();
        }

        protected void grdBugs_ItemCommand(object sender, GridViewCommandEventArgs e)
        {
            if (e.CommandName == "MarkAsFixed")
            {
                int bugId =  Int32.Parse((string)e.CommandArgument);

                Bug bugToMarkAsFixed = BugDAO.FindBy(bugId);

                if (bugToMarkAsFixed != null)
                    bugToMarkAsFixed.Fixed = true;

                BugDAO.Save(bugToMarkAsFixed);

                ShowApplication();
            }
        }

        protected void btnUpdateApplication_Click(object sender, EventArgs e)
        {
            Application application = ApplicationDAO.FindBy(CurrentApplicationId());

            application.Name = this.txtApplicationName.Text;
            application.MoreDetails = this.txtApplicationMoreDetails.Text;

            ApplicationDAO.Save(application);

            ShowApplication();
        }
    }
}
