﻿using System;
using System.Collections.Generic;
using System.Data.Objects;
using System.Linq;
using System.Web;

namespace ProEnt.Chap8.EFBugTracker.Model
{
    public class BugDAO
    {
        private BugTrackerDBEntities _db;

        public BugDAO()
        {
            _db = new BugTrackerDBEntities();
        }

        public List<Bug> FindAll()
        {
            return (_db.BugSet).ToList();            
        }

        public Bug FindBy(int Id)
        {
            return (_db.BugSet).First(a => a.BugId == Id);            
        }

        public void Save(Bug bug)
        {
            _db.SaveChanges();
        }

        public List<Bug> FindAllByApplication(int Id)
        {
            ObjectQuery<Bug> Allbugs = _db.BugSet;

            var bugs = from bug in Allbugs
                       where bug.Application.ApplicationId == Id 
                        select bug;

            return bugs.ToList();
        }
        
        public void Add(Bug bug)
        {
            _db.AddToBugSet(bug);
            _db.SaveChanges();
        }

        public void DeleteBy(int BugId)
        {
            Bug bugToDelete = FindBy(BugId);
            
            _db.DeleteObject(bugToDelete);

            _db.SaveChanges();
        }
    }
}
