﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace ProEnt.Chap8.LinqBugTracker.Model
{
    public class ApplicationDAO
    {
       private BugTrackerDataContext dataContext;

       public ApplicationDAO()
        {
            dataContext = new BugTrackerDataContext();
        }

        public List<Application> FindAll()
        {
            return dataContext.Applications.ToList();
        }
       
        public Application FindBy(int Id)
        {
            Application application = dataContext.Applications.SingleOrDefault(a => a.ApplicationId == Id); 
            application.Bugs.Load();
            return application;
        }

        public void Add(Application application)
        {
            dataContext.Applications.InsertOnSubmit(application);
            dataContext.SubmitChanges();
        }

        public void Delete(Application application)
        {
            // Remove all bugs linked to the Application
            dataContext.Bugs.DeleteAllOnSubmit(application.Bugs);
            // Remove the application
            dataContext.Applications.DeleteOnSubmit(application);
            dataContext.SubmitChanges();
        }

        public void Save(Application modifiedApplication)
        {
            dataContext.SubmitChanges();                                                       
        }
    }
}
