﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Collections.Generic;

namespace ProEnt.Chap8.LinqBugTracker.Model
{
    public class BugDAO
    {
        private BugTrackerDataContext dataContext;

        public BugDAO()
        {
            dataContext = new BugTrackerDataContext();
        }

        public List<Bug> FindAll()
        {
            return dataContext.Bugs.ToList();
        }
       
        public Bug FindBy(int Id)
        {
            Bug bug = dataContext.Bugs.SingleOrDefault(b => b.BugId == Id);             
            return bug;
        }

        public void Add(Bug bug)
        {
            dataContext.Bugs.InsertOnSubmit(bug);
            dataContext.SubmitChanges();
        }

        public void Delete(Bug bug)
        {
            dataContext.Bugs.DeleteOnSubmit(bug);
            dataContext.SubmitChanges();
        }

        public void Save(Bug bug)
        {
            dataContext.SubmitChanges();                                                       
        }
    }
}
