﻿using System;
using System.Linq;
using System.Web.UI.WebControls;
using ProEnt.Chap8.NHibernateBugTracker.Model;

namespace ProEnt.Chap8.NHibernateBugTracker
{
    public partial class ApplicationDetail : System.Web.UI.Page
    {
        ApplicationRepository _applicationRepository;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!this.IsPostBack)
            {
                ShowApplication();
            }
        }

        protected void grdBugs_RowDeleting(object sender, GridViewDeleteEventArgs e)
        {
            int bugId = (int)grdBugs.DataKeys[e.RowIndex].Values[0];

            Application application = ApplicationRepository.FindBy(CurrentApplicationId());

            Bug bugToRemove = application.Bugs.FirstOrDefault(b => b.BugId == bugId);

            if (bugToRemove != null)
                application.Bugs.Remove(bugToRemove);

            ApplicationRepository.Save(application);

            ShowApplication();
        }

        private void ShowApplication()
        {
            Application application = ApplicationRepository.FindBy(CurrentApplicationId());
            this.litApplicationName.Text = application.Name;
             
            this.grdBugs.DataSource = application.Bugs;
            this.grdBugs.DataBind(); 
        }

        private ApplicationRepository ApplicationRepository
        {
            get
            {
                if (_applicationRepository == null)
                    _applicationRepository = new ApplicationRepository();

                return _applicationRepository;
            }
        }

        public int CurrentApplicationId()
        {
            int applicationId;
            applicationId = Int32.Parse(Request.QueryString["ApplicationId"]);
            return applicationId;
        }

        public Boolean IsNotFixed(Boolean isFixed)
        {
            return !isFixed;
        }

        protected void btnAddBug_Click(object sender, EventArgs e)
        {
            Application application = ApplicationRepository.FindBy(CurrentApplicationId());
            Bug newBug = new Bug();

            newBug.Application = application;
            newBug.Desc = this.txtBugDesc.Text;
            application.Bugs.Add(newBug);

            ApplicationRepository.Save(application);

            ShowApplication();
        }

        protected void grdBugs_ItemCommand(object sender, GridViewCommandEventArgs e)
        {
            if (e.CommandName == "MarkAsFixed")
            {
                int bugId =  Int32.Parse((string)e.CommandArgument);

                Application application = ApplicationRepository.FindBy(CurrentApplicationId());

                Bug bugToMarkAsFixed = application.Bugs.FirstOrDefault(b => b.BugId == bugId);

                if (bugToMarkAsFixed != null)
                    bugToMarkAsFixed.Fixed = true;

                ApplicationRepository.Save(application);

                ShowApplication();
            }
        }
    }
}
