﻿using System.Collections.Generic;
using NHibernate;

namespace ProEnt.Chap8.NHibernateBugTracker.Model
{
    public class ApplicationRepository
    {
              
        public List<Application> FindAll()
        {

            using (ISession NSession = SessionProvider.GetSession())
            {

                NHibernate.ICriteria CriteriaQuery = NSession.CreateCriteria(typeof(Application));

                return (List<Application>) CriteriaQuery.List<Application>();

            }
        }
       
        public Application FindBy(int Id)
        {
            using (ISession NSession = SessionProvider.GetSession())
            {
                return NSession.Get<Application>(Id);
            }
        }

        public void Add(Application application)
        {
            using (ISession NSession = SessionProvider.GetSession())
            {
                using (ITransaction Transaction = NSession.BeginTransaction())
                {
                    NSession.Save(application);
                    Transaction.Commit();
                }
            }
        }

        public void Delete(Application application)
        {
            using (ISession NSession = SessionProvider.GetSession())
            {
                using (ITransaction Transaction = NSession.BeginTransaction())
                {
                    NSession.Delete(application);
                    Transaction.Commit();
                }
            }
        }

        public void Save(Application modifiedApplication)
        {            
            using (ISession NSession = SessionProvider.GetSession())
            {
               using (ITransaction Transaction = NSession.BeginTransaction())
               {
                   NSession.SaveOrUpdate(modifiedApplication);
                   Transaction.Commit();
               }
                                               
            }                               
        }
    }
}
